﻿!function($) {
    //基础弹出类
    var Panel = function(attr) {
        this.parent = top.document.body;
        this.content = '';
        this.width = 0;
        this.height = 0;
        this.x = 0;
        this.y = 0;
        this.zIndex = 999;
        this.display = false;
        if (attr != null && typeof (attr) == 'object') {
            this._iterates(attr, this);
            this._init();
        }
    };
    Panel.prototype = {
        _init: function() {
            this.onbefore && this.onbefore();
            this._append(this.content);
            this._setCss();
            if (!this.display) this.hide(); //默认隐藏
            this.setWH(this.width, this.height); //设置默认宽高
            this.setXY(this.x, this.y); //设置默认位置
            this.onload && this.onload();
        }
        //创建Panel
	, _append: function(content) {
	    var obj = $('<div >' + content + '</div>').appendTo(this.parent)
	    this.obj = $(obj);
	}
	, _setCss: function() {
	    this.setCss({
	        position: 'fixed'
			, 'z-index': this.zIndex
	    })
	}
	, _iterates: function(object, pro) {//遍历属性，设置为本类属性
	    for (var key in object) {
	        pro[key] = object[key];
	    }
	}

	, setContent: function(content) {
	    this.obj.append(content);
	}
	, show: function() {
	    this.obj.show();
	    this.onshow && this.onshow();
	}
	, hide: function() {
	    this.obj.hide();
	    this.onhide && this.onhide();
	}
	, dispose: function() {
	    this.obj.remove();
	    this.onclose && this.onclose();
	}
	, center: function() {
	    var dc = top.document.documentElement || top.document.body;
	    var width = dc.clientWidth;
	    var height = dc.clientHeight;
	    var thisWidth = this.obj.width();
	    var thisHeight = this.obj.height();
	    var x = (width - thisWidth) / 2;
	    var y = (height - thisHeight) / 2;
	    if (x < 0) x = 0;
	    if (y < 0) y = 0;
	    this.setXY(x, y);
	}
	, full: function() {
	    var width = $(top).width();
	    var height = $(top).height();
	    this.setCss({ left: 0, top: 0, width: width + 'px', height: height + 'px', position: "fixed" });
	    this.onfull && this.onfull();
	}
	, setCss: function(data) {
	    this.obj.css(data);
	}
	, setXY: function(x, y) {
	    if (x) this.obj.css({ left: x + 'px' });
	    if (y) this.obj.css({ top: y + 'px' });
	}
	, setWH: function(width, height) {
	    if (width != null) this.setWidth(width);
	    if (height != null) this.setHeight(height);
	}
	, setWidth: function(width) {
	    this.obj.css({ width: width + 'px' });
	}
	, setHeight: function(height) {
	    this.obj.css({ height: height + 'px' });
	}


    };
    $.panel = function(options) {
        return new Panel(options);
    };
    var AllZindex = 999;
    var dialog = function(config) {
        if (config != null && typeof (config) == 'object') {
            this._iterates(config, this);
            this._init();
        }

    };
    dialog.prototype = {
        tmpl: '1'
	, css: 'ui-dialog'
	, header: true
	, footer: true
	, cue: false
	, mask: true
	, zIndex: 999
	, _tmpl: {
	    '1': '<div class="{%css%}">\
			<div class="ui-panel-title"></div>\
			<div class="ui-panel-content"></div>\
			<div class="ui-panel-footer"></div>\
			<span class="co1"><span></span></span>\
			<span class="co2"><span></span></span>\
			<span class="cue"><span></span></span>\
			<span class="close"></span>\
		</div>'
	}
	, addTmpl: function(name, con) {
	    this._tmpl[name] = con;
	}
	, _init: function() {
	    AllZindex += 1;
	    this.zIndex = AllZindex;
	    if (this.mask) {
	        this.maskPanel = new Panel({
	            zIndex: this.zIndex - 1
				, content: '<iframe style="width:100%;height:100%;filter:alpha(opacity:0);opacity:0" scrolling="no" frameborder="no"></iframe>'
	        });
	        this.maskPanel.setCss({ 'background-color': '#333', opacity: 0.5 });
	    }
	    this.core = new Panel({ content: this._tmpl[this.tmpl].replace('{%css%}', this.css), width: this.width, height: this.height, zIndex: this.zIndex });
	    this._event();
	    if (this.header == false) {
	        this.core.obj.find('.ui-panel-title').hide();
	    }
	    if (this.footer == false) {
	        this.core.obj.find('.ui-panel-footer').hide();
	    }
	    if (this.cue == false) {
	        this.core.obj.find('.cue').hide();
	    }

	    this.onload && this.onload();
	}
	, _iterates: function(object, pro) {
	    for (var key in object) {
	        pro[key] = object[key];
	    }
	}
	, _event: function() {
	    var pro = this;
	    this.core.obj.find('.close').click(function() {
	        pro.dispose();
	        pro.onclick && pro.onclick('close');
	    });
	}
	, show: function() {
	    if (this.mask) this.maskPanel.show();
	    if (this.mask) this.maskPanel.full();
	    this.core.show();
	    this.onshow && this.onshow();
	}
	, setTitle: function(con, isClear) {
	    var obj = this.core.obj.find('.ui-panel-title');
	    if (isClear) obj.html('');
	    obj.append(con);
	}
	, setContent: function(con, isClear) {
	    var obj = this.core.obj.find('.ui-panel-content');
	    if (isClear) obj.html('');
	    obj.append(con);
	}
	, setFooter: function(con, isClear) {
	    var obj = this.core.obj.find('.ui-panel-footer');
	    if (isClear) obj.html('');
	    return $(con).appendTo(obj);
	}
	, setCue: function(css) {
	    this.core.obj.find('.cue').css(css);
	}
	, hide: function() {
	    this.core.hide();
	    if (this.mask) this.maskPanel.hide();
	    this.onhide && this.onhide();
	}
	, dispose: function() {
	    this.core.dispose();
	    if (this.mask) this.maskPanel.dispose();
	    this.ondispose && this.ondispose();
	}
	, center: function() {
	    this.core.center();
	}
	, full: function() {
	    this.core.full();
	}
	, setXY: function(x, y) {
	    this.core.setXY(x, y);
	}
	, setWH: function(width, height) {
	    this.core.setWH(width, height);
	}
	, setWidth: function(width) {
	    this.core.setWidth(width);
	}
	, setHeight: function(height) {
	    this.core.setHeight(height);
	}
	, getWidth: function() {
	    return parseInt(this.core.obj.css('width'));
	}
	, getHeight: function() {
	    return parseInt(this.core.obj.css('height'));
	}
	, getLeft: function() {
	    return parseInt(this.core.obj.css('left'));
	}
	, getTop: function() {
	    return parseInt(this.core.obj.css('top'));
	}
    };
    $.dialog = function(options) {
        return new dialog(options);
    };
    var messagebox = function(config) {
        if (typeof (config) == 'object') {
            this._iterates(config, this);
        }
        this._init();
        var pro = this;

        if (this.button != null) {
            for (var i = 0; i < this.button.length; i++) {
                var type = this.button[i];
                var button = this.setFooter(this.buttonConfig[type]);
                $(button).click(function(t) {
                    return function() { pro.onclick && pro.onclick(t); }
                } (type))
            }
        }

        this.center();
    };
    messagebox.ok = 'ok';
    messagebox.cancel = 'cancel';
    messagebox.prototype = dialog.prototype;
    messagebox.prototype.buttonConfig = {
        'ok': '<a href="javascript:;" class="ui-panel-ok"></a>'
	, 'cancel': '<a href="javascript:;" class="ui-panel-cancel"></a>'
    };
    messagebox.prototype.addButton = function(name, con) {
        this.buttonConfig[name] = con;
    };
    $.messagebox = function(options) {
        return new messagebox(options);
    };
    $.message = function(con, title, width) {
        title = title || '提示信息';
        width = width || 300;
        var nm = new messagebox({ width: width, css: 'ui-mesagebox' });
        nm.setTitle(title);
        nm.setContent(con)
        nm.show();
        nm.center();
        return nm;
    }
    $.alert = function(con, callback, title, width, okName) {
        title = title || '提示信息';
        width = width || 300;
        var nm = new messagebox({ width: width, css: 'ui-mesagebox', button: [messagebox.ok] });
        nm.setTitle(title);
        nm.setContent(con)
        nm.show();
        nm.center();
        nm.onclick = function(type) {
            if (type == 'ok') {
            	if (callback) {
                    var eInfo = callback();
                    if (eInfo != false) nm.dispose();
                } else nm.dispose();
            	
                
            }
        }
        okName = okName || "确定";
        $(nm.core.obj).find('.ui-panel-ok').html(okName);
        return nm;
    };

    $.confirm = function(con, callback, errcallback, title, width, isCheck, okName, cancelName) {
        title = title || '确认提示信息';
        width = width || 300;
        var nm = new messagebox({ width: width, css: 'ui-mesagebox', button: [messagebox.ok, messagebox.cancel] });
        nm.setTitle(title);
        nm.setContent(con)
        nm.show();
        nm.center();
        nm.onclick = function(type) {
            if (type == 'ok') {
                if (callback) {
                    var eInfo = callback();
                    if (eInfo != false) nm.dispose();
                } else nm.dispose();
            } else if (type == 'cancel') {
                nm.dispose();
                errcallback && errcallback();
            }
        };
        okName = okName || "确定";
        cancelName = cancelName || "取消";
        $(nm.core.obj).find('.ui-panel-ok').html(okName);
        $(nm.core.obj).find('.ui-panel-cancel').html(cancelName);
        return nm;
    }
    $.popup = function(con, obj, x, y, callback) {
        var width = $(window).width();
        var height = $(window).height();

        var nm = new dialog({ css: 'ui-popup', footer: false, header: false, cue: true, mask: false, zIndex: 100 });
        nm.setContent(con);
        nm.show();
        var thisWidth = nm.getWidth();
        var thisHeight = nm.getHeight();


        var offset = $(obj).offset();
        var left = offset.left;
        var top = offset.top;
        x = x != null ? x : 0;
        y = y != null ? y : 20;
        if (left + thisWidth > width) {
            left = left - thisWidth + 20;
            x = thisWidth - x - 20;
        }
        nm.setCue({ top: -y, left: x });
        nm.setXY(left, top + y * 2);
        nm.onclick = function(type) {
            if (type == 'close') {
                nm.dispose();
                callback && callback();
            }
        };
        return nm;
    }
    $.fn.popup = function(con, type) {
        var popup = $(this).data('popup');
        if (type != 0) {
            if (!popup) {
                var newclass = $.popup(con, $(this));
                $(this).data('popup', newclass);
            } else {
                popup.show();
            }
        } else {
            popup.hide();
        }

    }

    $.layer = {
        open: function(path, title, width, height, callback, getcallback, css) {
            title = title || '弹出层';
            width = width || 800;
            funName = 'layer_' + Math.random();
            top[funName] = function(data, type) {
                if (data == null) {
                    if (type == 'close') nm.dispose();
                    else if (type == 'get') return getcallback && getcallback();
                } else {
                    callback && callback(data);
                }
            }
            var nm = new messagebox({ width: width, height: height, css: (css || 'ui-mesagebox') });
            nm.setTitle(title);
            nm.setContent('<iframe src="' + path + (path.indexOf('?') > -1 ? '&' : '?') + 'LayerCallBack=' + funName + '" style="width:100%;height:'+(height-86)+'px;" scrolling="yes" frameborder="0" ></iframe>')
            nm.show();
            nm.center();

            return nm;
        }
        , close: function() {
            var fun = $.string.path(location.href)['LayerCallBack'];
            top[fun] && top[fun](null, 'close');
        }
        , get: function() {
            var fun = $.string.path(location.href)['LayerCallBack'];
            return top[fun] && top[fun](null, 'get');
        }
        , set: function(data) {
            var fun = $.string.path(location.href)['LayerCallBack'];
            top[fun] && top[fun](data);
        }
    };
} (jQuery);