﻿
/*基础类*/
(function($) {
    $._offset = function(obj, scrOnOff) {
        obj=$(obj).get(0);
        var left = 0, top = 0;
        var width = obj.offsetWidth, height = obj.offsetHeight;
        do { left += obj.offsetLeft - (scrOnOff ? obj.scrollLeft : 0), top += obj.offsetTop - (scrOnOff ? obj.scrollTop : 0); } while (obj = obj.offsetParent);
        return { 'left': left, 'top': top, 'width': width, 'height': height };
    };
    $.tmpl = function(text, opts, key) {
        return $.string.tmpl(text, opts, key);
    };
    $.tmpls = function(text, list, key) {
        var str=[];
        for(var i=0;i<list.length;i++){
        	str[str.length]=$.tmpl(text,list[i],key);
        }
        return str.join('');
    };
    $.tmplWrite = function(css,attr,data){
		$(css).each(function(){
			var con=$(this).attr(attr);
			$(this).html($.tmpl(con,data));
		})
	}
    $.tmplList=function(id,tmplid,data,type){
    	if(type==1){
    		return $($.string.analyze($.tmpls($(tmplid).html(),data))).appendTo(id);
    	}else if(type==2){
    		return $($.string.analyze($.tmpls($(tmplid).html(),data))).prependTo(id);
    	}else{
    		$(id).html($.string.analyze($.tmpls($(tmplid).html(),data)))
    	}
    	
    }
    $.toJs = function(jsonText) {
        /*说明：把json字符串转换成js */
        return $.string.toJs(jsonText);

    };
    $.outerHTML = function(obj) {
        return $(obj).prop('outerHTML');
    }
    $.json = function(js) {
        /*将数组转换成字符串*/
        return JSON.stringify(js).replace(/\"/g, '\'');

    }
    $.jsontext = function(js) {
        /*将数组转换成字符串*/
        return $.encode4HtmlValue(JSON.stringify(js));
    }
    $.encode4HtmlValue = function(s) {
        return $.encode4Html(s).replace(/"/g, "&quot;").replace(/'/g, "&#039;");
    }
    $.encode4Html = function(s) {
        var el = document.createElement('pre'); //这里要用pre，用div有时会丢失换行，例如：'a\r\n\r\nb'
        var text = document.createTextNode(s);
        el.appendChild(text);
        return el.innerHTML;
    }
    $.windowInfo = function() {
        /*获取document.documentElement信息*/
        var dc = document.documentElement || document.body;
        return { client: { width: dc.clientWidth, height: dc.clientHeight }, scroll: { width: dc.scrollWidth, height: dc.scrollHeight, top: dc.scrollTop, left: dc.scrollLeft} };
    }
    $.client = function() {
        return $.windowInfo().client;
    }
    $.getIframe = function(id, parentWindow) {
        /*说明：获取页面内iframe的window */
        /*参数：id：页面内iframe的ID parentWindow：使用环境(window|parent|top) */
        parentWindow = parentWindow || window;
        var list = parentWindow.document.getElementsByTagName('iframe'), len = list.length, i = 0;
        for (; i < len; i++) {
            if (list[i].id == id) {
                return parentWindow.frames[i];
            }
        }
        return null;
    }
    $.getIframeNode = function() {
        /*说明：iframe页面里寻找父页面下当前iframe标签*/
        var list = parent.frames, len = list.length, i = 0;
        for (; i < len; i++) {
            if (list[i] == window) {
                return parent.document.getElementsByTagName('iframe')[i];
            }
        }
        return null;
    }
    $._param = function(params, connector) {

        connector = connector || ['=', '&'];
        var list = [];
        for (var key in params) {
            list[list.length] = key + connector[0] +encodeURIComponent(params[key]);
        }
        return list.join(connector[1]);
    }
    $.browser = (function() {
        /*获取窗体信息*/
        var na = window.navigator, ua = na.userAgent.toLowerCase();
        var b = {
            platform: na.platform,
            msie: /msie/.test(ua) && !/opera/.test(ua),
            opera: /opera/.test(ua),
            safari: /webkit/.test(ua) && !/chrome/.test(ua),
            firefox: /firefox/.test(ua),
            chrome: /chrome/.test(ua)
        };
        var vMark = "";
        for (var i in b) {
            if (b[i]) vMark = i;
        }
        if (b.safari) vMark = "version";
        b.version = (ua.match(new RegExp("(?:" + vMark + ")[\\/: ]([\\d.]+)")) || [])[1];
        b.ie = b.msie;
        b.ie6 = b.msie && parseInt(b.version) == 6;
        b.ie7 = b.msie && parseInt(b.version) == 7;
        b.ie8 = b.msie && parseInt(b.version) == 8;
        b.ie9 = b.msie && parseInt(b.version) == 9;
        b.ie10 = b.msie && parseInt(b.version) == 10;
        b.ie11 = b.msie && parseInt(b.version) == 11;
        try { b.maxthon = b.msie && !!external.max_version; } catch (ex) { }
        return b;
    })();
    /*event*/
    $._event = {
        KEY_BACKSPACE: 8//退格键
		, KEY_TAB: 9//Tab 键
		, KEY_RETURN: 13//回车键
		, KEY_ESC: 27//Esc 键
		, KEY_LEFT: 37//左箭头键
		, KEY_UP: 38//上箭头键
		, KEY_RIGHT: 39//右箭头键
		, KEY_DOWN: 40//下箭头键
		, KEY_DELETE: 46//删除键
		, element: function() {
		    /*说明：返回触发事件的元素 */
		    return event.target || event.srcElement;
		}
		, position: function() {
		    /*获取当前鼠标位置(x,y)*/
		    return {
		        'x': event.pageX || (event.clientX + (document.documentElement || document.body).scrollLeft)
			, 'y': event.pageY || (event.clientY + (document.documentElement || document.body).scrollTop)
		    }
		}
		, findElement: function(tagName, callBack) {
		    /*说明：从触发事件的元素向上遍历 DOM 树，查找第一个名为目标标签名的元素。 */
		    /*参数：tagName: 目标标签名*/
		    var element = this.element();
		    while (element.parentNode && (!element.tagName || (element.tagName.toUpperCase() != tagName.toUpperCase()))) {
		        if (callBack && callBack(element)) return element;
		        element = element.parentNode;
		    }
		    return element;
		}
		, isLeftClick: function() {
		    /*说明：如果左键被按下则返回 true */
		    return (((event.which) && (event.which == 1)) || ((event.button) && (event.button == 1)));
		}
		, inTow: function(obj, data) {
		    data = data || {};
		    data.moveCallBack = data.moveCallBack || function(x, y, x1, y1) {
		        $(obj).css({ left: x, top: y });
		    }
		    data.obj = obj;
		    new InTow(data);
		}
		, inTowEdge: function(data) {
		    var intowObj = data.obj;
		    var downCallBack = data.down || function() { };
		    var moveCallBack = data.move || function() { };
		    var upCallBack = data.up || function() { };
		    var inTowObjType = "move";
		    var offset = $._offset($(intowObj).parent().get(0)); ;
		    $(intowObj).mousedown(function() {
		        downCallBack && downCallBack();
		        var thisOffset = $._offset(this);
		        
		        if (inTowObjType == "move") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                
		                var d = { left: x - offset.left, top: y - offset.top };
		                $(intowObj).css(d);
		                moveCallBack(d, inTowObjType);
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "left-top") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { left: x - offset.left, top: y - offset.top, width: thisOffset.width + thisOffset.left - x, height: thisOffset.height + thisOffset.top - y };
		                $(intowObj).css(d);
		                moveCallBack(d, inTowObjType);
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "left") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { left: x - offset.left, width: thisOffset.width + thisOffset.left - x };
		                $(intowObj).css(d);
		                d.top=thisOffset.top;
		                moveCallBack(d, inTowObjType);
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "left-bottom") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { left: x - offset.left, width: thisOffset.width + thisOffset.left - x, height: y - thisOffset.top + thisOffset.height };
		                $(intowObj).css(d);
		                d.top=thisOffset.top;
		                moveCallBack(d, inTowObjType); ;
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "bottom") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { height: y - thisOffset.top + thisOffset.height };
		                $(intowObj).css(d);
		                d.left=thisOffset.left;
		                d.top=thisOffset.top;
		                moveCallBack(d, inTowObjType);
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "right-bottom") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { width: x - thisOffset.left + thisOffset.width, height: y - thisOffset.top + thisOffset.height };
		                $(intowObj).css(d);
		                d.left=thisOffset.left;
		                d.top=thisOffset.top;
		                moveCallBack(d, inTowObjType); ;
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "right") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { width: x - thisOffset.left + thisOffset.width };
		                $(intowObj).css(d);
		                d.left=thisOffset.left;
		                d.top=thisOffset.top;
		                moveCallBack(d, inTowObjType);
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "right-top") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { width: x - thisOffset.left + thisOffset.width, top: y - offset.top, height: thisOffset.height + thisOffset.top - y };
		                $(intowObj).css(d);
		                d.left=thisOffset.left;
		                moveCallBack(d, inTowObjType);
		                
		            }, upCallBack: upCallBack
		            })
		        } else if (inTowObjType == "top") {
		            $._event.inTow($(this), { moveCallBack: function(x, y, x1, y1) {
		                var d = { top: y - offset.top, height: thisOffset.height + thisOffset.top - y };
		                $(intowObj).css(d);
		                d.left=thisOffset.left;
		                moveCallBack(d, inTowObjType);
		                
		            }, upCallBack: upCallBack
		            })
		        }
		    });
		    $(intowObj).mousemove(function() {
		        var pos = $._event.position();
		        
		        var offset = $._offset(this);
		        var type = 'move';
		        inTowObjType = 'move';
		        var thisPost = { x: pos.x - offset.left, x2: (offset.left + offset.width) - pos.x, y: pos.y - offset.top, y2: (offset.top + offset.height) - pos.y };
		        if (thisPost.x < 8 && thisPost.y < 8) {
		            type = "se-resize";
		            inTowObjType = 'left-top';
		        } else if (thisPost.x < 8 && thisPost.y > 8 && thisPost.y2 > 8) {
		            type = "w-resize";
		            inTowObjType = 'left';
		        } else if (thisPost.x < 8 && thisPost.y2 < 8 && thisPost.x2 > 8) {
		            type = "ne-resize";
		            inTowObjType = 'left-bottom';
		        } else if (thisPost.x > 8 && thisPost.y2 < 8 && thisPost.x2 > 8) {
		            type = "n-resize";
		            inTowObjType = 'bottom';
		        } else if (thisPost.y > 8 && thisPost.y2 < 8 && thisPost.x2 < 8) {
		            type = "se-resize";
		            inTowObjType = 'right-bottom';
		        } else if (thisPost.y > 8 && thisPost.y2 > 8 && thisPost.x2 < 8) {
		            type = "w-resize";
		            inTowObjType = 'right';
		        } else if (thisPost.y < 8 && thisPost.x2 < 8) {
		            type = "ne-resize";
		            inTowObjType = 'right-top';
		        } else if (thisPost.y < 8 && thisPost.x > 8 && thisPost.x2 > 8) {
		            type = "n-resize";
		            inTowObjType = 'top';
		        }
		        //move,se-resize,w-resize,ne-resize,n-resize
		        $(this).css({ 'cursor': type })
		    })
		}
		, capture: function(obj, num) {
		    if (document.all) {
		        num ? obj.setCapture() : obj.releaseCapture();
		    }
		}
		, cleanOutSelect: function() {
		    try {
		        document.selection.empty();
		    } catch (exp) {
		        try {
		            window.getSelection().removeAllRanges();
		        } catch (exp) { }
		    }
		}
		, shake: function(data) {
		    if (data == null) {
		        $(window).unbind('devicemotion');
		        return;
		    }
		    data = data || {};
		    if (data.speed == null) data.speed = 2000;
		    if (data.is == null) data.is = function() { return true; }
		    var SHAKE_THRESHOLD = data.speed;
		    var last_update = 0;
		    var x, y, z, last_x, last_y, last_z;
		    if (window.DeviceMotionEvent) {
		        $(window).bind('devicemotion', function(eventData) {
		            var acceleration = eventData.accelerationIncludingGravity;
		            var curTime = new Date().getTime();
		            if ((curTime - last_update) > 100) {
		                var diffTime = curTime - last_update;
		                last_update = curTime;
		                x = acceleration.x;
		                y = acceleration.y;
		                z = acceleration.z;
		                var speed = Math.abs(x + y + z - last_x - last_y - last_z) / diffTime * 10000;
		                if (speed > SHAKE_THRESHOLD && data.is()) {
		                    data.callback && data.callback();
		                }
		                last_x = x;
		                last_y = y;
		                last_z = z;
		            }
		        });
		    }
		}
		, gyro: function(data) {
		    data = data || {};
		    if (window.DeviceMotionEvent) {
		        window.addEventListener('devicemotion', function(eventData) {
		            var acceleration = eventData.accelerationIncludingGravity;
		            data.move && data.move(acceleration.x, acceleration.y, acceleration.z);
		        }, false);
		    }
		}
    };
    var InTow = function(newObj) {
        var pro = this;
        this.moveEvent = 'mousemove';
        this.upEvent = 'mouseup';
        this.parent=document;
        this.rewriteAtt(pro, newObj);
        this.event();
    }

    InTow.prototype = {
        onOff: false
	, left: -10000, right: 10000, top: -10000, bottom: 10000
	, rewriteAtt: function(formerObj, newObj) {//给对象设置属性
	    for (var i in newObj) {
	        formerObj[i] = newObj[i];
	    }
	    return formerObj;
	}
	, event: function() {
	    var pro = this;
	    var doc = $(this.parent);
	    this.moveFun = function(e) { if (pro.onOff) pro.move(e); }
	    this.upFun = function(e) { if (pro.onOff) { pro.up(e); doc.unbind(pro.moveEvent, pro.moveFun); doc.unbind(pro.upEvent, pro.upFun); } }
	    doc.bind(pro.moveEvent, pro.moveFun);
	    doc.bind(pro.upEvent, pro.upFun);
	    this.down(this.e);
	}
	, down: function(e) {
	    if (!this.obj) return;
	    var xy  = (e!=null && /touch/.test(e.type) )? { x: e.originalEvent.touches[0].pageX, y: e.originalEvent.touches[0].pageY} : $._event.position();
	    
	    $._event.capture(this.obj, 1);
	    var offset = $._offset((typeof this.obj == 'object') ? this.obj.get(0) : this.obj);
	    this.downTop = xy.y - offset.top;
	    this.downLeft = xy.x - offset.left;
	    this.onOff = true;
	    this.downCallBack && this.downCallBack();
	}
	, moveOnOff: true
	, move: function(e) {
	    if (!this.moveOnOff) return;
	    var xy = (e!=null && /touch/.test(e.type) )? { x: e.originalEvent.touches[0].pageX, y: e.originalEvent.touches[0].pageY} : $._event.position();
	    
	    var y = xy.y - this.downTop, x = xy.x - this.downLeft;
	    y = y > this.bottom ? this.bottom : (y < this.top ? this.top : y);
	    x = x > this.right ? this.right : (x < this.left ? this.left : x);
	    var scroll = $.windowInfo().scroll;
	    this.moveCallBack && this.moveCallBack(x - scroll.left, y - scroll.top, xy.x, xy.y);
	    $._event.cleanOutSelect();
	}
	, up: function() {
	    this.onOff = false;
	    $._event.capture(this.obj, 0);
	    this.upCallBack && this.upCallBack();
	}
	, stop: function() {
	    this.upFun();
	}
    }

    $.fn.inTow = function(data) {
        $._event.inTow(this, data);
    }
    /*表单类*/
    $.from = {
        get: function(parentid) {
            /*获取parentid表单内所有name对应的值*/
            parentid = parentid || document.body;
            var attr = {};
            $(parentid).find('[name]').each(function() {
                if (this.name == undefined) return;
                var value = this.value;
                if (this.type == 'radio' || this.type == 'checkbox') {
                    if (this.checked) {
                        if (attr[this.name] == null) attr[this.name] = value;
                        else attr[this.name] = attr[this.name] + ',' + value;
                    }
                } else {
                    if (attr[this.name] == null) attr[this.name] = value;
                    else {
                        if (attr[this.name].constructor != Array) {
                            attr[this.name] = [attr[this.name]];
                        }
                        attr[this.name][attr[this.name].length] = value;
                    }
                }

            });
            var newAttr = {};
            for (var key in attr) {
                if (attr[key].constructor == Array) newAttr[key] = attr[key].join(',');
                else newAttr[key] = attr[key];
            }

            return newAttr;
        }
        //        , set: function(parentid, data) {
        //            parentid = parentid || document.body;
        //            if (data == null) data = { key: 'name', data: [],callback:function(e){return e.data} };
        //            var key = data.key || 'name';
        //            var callback= data.callback || function(e){return e.data} ;
        //            if (data.path != null)
        //                $.post(data.path,{},function(e){
        //                    var d=callback(e);
        //                    if(!d)d={};
        //                    $(parentid).find('['+key+']').each(function() {
        //                        var attr=$(this).attr(key);
        //                        if(d[key]){
        //                            $(this).val(d[key]);
        //                        }
        //                        
        //                    });
        //                })
        //                
        //            }
        //        }
		, write: function(tmpl, list) {
		    /*循环输出模板*/
		    var str = [];
		    $.array.each(list, function(o, key) {
		        str[str.length] = $.string.analyze($.tmpl(tmpl, o));
		    });
		    return str.join('');
		}

		, post: function(path, tmpl, callback) {
		    /*异步请求获取数据*/
		    $.post(path, {}, function(data) {
		        data = $.toJs(data);
		        callback && callback($.from.write(tmpl, data));
		    })
		}
		, tab: function(parentid, callback) {
		    /*选项卡*/
		    var obj = $(document);
		    if (parentid) obj = $(parentid);
		    var hideList = function(list) {
		        for (var i = 0; i < list.length; i++) {
		            list[i].hide();
		        }
		    }
		    obj.find('[bindtab]').each(function() {
		        var _obj = $(this);
		        var data = $.toJs(_obj.attr('bindtab'));
		        if (!data) data = {};
		        var css = data.css || 'on';
		        var event = data.event || 'click';
		        var index = data.index || 0;
		        var list = _obj.find('[tabfor]');
		        var divList = [];
		        var eventFun = function(o) {
		            hideList(divList);
		            list.removeClass(css);
		            $($(o).attr('tabfor')).show();
		            $(o).addClass(css);
		            callback && callback(o, key);
		        }
		        list.each(function(key) {
		            divList[divList.length] = $($(this).attr('tabfor'));
		            $(this).bind(event, function() {
		                eventFun(this);
		            });
		        });
		        eventFun(list.get(index));
		    });
		}
		, select: function(parentid, path) {
		    /*输出下拉菜单*/
		    var runBind = function(obj, type) {
		        var obj = $(obj);
		        var tmpl = '<option value="${Value}">${Name}</option>';

		        var Option = obj.attr('Option');
		        var value = obj.attr('BindValue');
		        var isChange = obj.attr('IsChange');
		        Option = Option == null ? '请选择' : Option;
		        if (Option.indexOf('{') > -1) {
		            Option = $.toJs(Option);
		        } else {
		            Option = { Name: Option, Value: '' };
		        }
		        var callback = function(html) {
		            obj.html($.tmpl(tmpl, Option) + html);
		            if (value != null && value != '') {
		                if ($(obj).find('option[value="' + value + '"]').length > 0) {
		                    obj.val(value);
		                }
		                if (isChange) obj.change();
		            }
		        }
		        var path = path || '/AjaxPost/GetValueList/?ParentCode=';

		        if (type.indexOf('[') > -1) {
		            callback($.from.write(tmpl, $.toJs(type)));
		        } else if (type.indexOf('0-') > -1) {
		            $.from.post(path + type, tmpl, callback)
		        } else if (type.indexOf('/') > -1) {
		            $.from.post(type, tmpl, callback);
		        } else {
		            $.from.post('/AjaxPost/GetSqlSelect/?sql=' + type, tmpl, callback);
		        }
		        var cycClear = function(obj) {
		            var next = $(obj).attr('BindNext');
		            if (next != null) {
		                $(next).html('');
		                cycClear(next);
		            }
		        }
		        var BindNext = obj.attr('BindNext');
		        if (BindNext != null) {
		            obj.change(function() {
		                cycClear(this);
		                if (this.value == '') return;

		                var nObj = obj.parent().find(BindNext);
		                if (nObj.get(0) == null) {
		                    if (BindNext.indexOf('#') > -1) nObj = $(BindNext);
		                    else nObj = $('#' + BindNext);
		                }
		                runBind(nObj, type + '-' + this.value);
		            });
		        }

		        var BindFun = obj.attr('BindFun');
		        if (BindFun != null) {
		            obj.change(function() {
		                window[BindFun] && window[BindFun](this.value, this);
		            });

		        }
		    }
		    var obj = $(document);
		    if (parentid) obj = $(parentid);
		    obj.find('[BindSelect]').each(function() {
		        var obj = $(this);
		        if ($(this).parents('[notbind]').length > 0) return;
		        var type = obj.attr('BindSelect');
		        runBind(this, type);
		    })
		}
		, calendar: function(parentid) {
		    /*
		    calendar 日期模板 calendar="yyyy-MM-dd HH:mm:ss"
		    mindate 最小日期 mindate="2013-12-12"
		    maxdate 最大日期
		    maxdate="%y-%M-%d" 只能选择今天以前的日期(包括今天)
		    mindate="%y-%M-#{%d+1}" 使用了运算表达式只能选择今天以后的日期(不包括今天)
		    mindate="%y-%M-01"  maxdate="%y-%M-%ld" 只能选择本月的日期1号至本月最后一天
		    mindate="%y-%M-%d #{%H-20}:%m:%s" maxdate="%y-%M-%d #{%H+30}:%m:%s" 使用了运算表达式只能选择 20小时前至 30小时后的日期
        
		    示例4-3-2 前面的日期+3天 不能大于 后面的日期 
		    <input type="text" id="d4321" calendar="" maxdate="#F{$dp.$D(\'d4322\',{d:-3});}"/>
		    <input type="text" id="d4322" calendar="" minDate="#F{$dp.$D(\'d4321\',{d:3});}"/>
		    */
		    var obj = $(document);
		    if (parentid) obj = $(parentid);
		    obj.find('[calendar]').each(function() {
		        if ($(this).parents('[notbind]').length > 0) return;
		        var calendar = $(this).attr('calendar');
		        var mindate = $(this).attr('mindate');
		        var maxdate = $(this).attr('maxdate');
		        $(this).focus(function() {
		            var data = { lang: 'zh-cn', position: { left: 0, top: 10} };
		            if (calendar != '') data.dateFmt = calendar;
		            if (mindate != null) data.minDate = mindate;
		            if (maxdate != null) data.maxDate = mindate;
		            WdatePicker(data);
		            this.blur();
		        });
		    })
		}
		, count: function(parentid) {
		    var obj = $(document);
		    if (parentid) obj = $(parentid);
		    obj.find('[js-count]').each(function() {
		        var data = $.toJs($(this).attr('js-count'));
		        var max = data.max || 200;
		        var showObj = $(this).parent().find(data.showID);
		        var pevText = "";
		        var length = 0;
		        $(this).keydown(function() {
		            length = pevText.length;
		            var value = $(this).val();
		            if (value.length > max) {
		                length = max;
		                value = pevText;
		                $(this).val(pevText);
		            }
		            pevText = value;
		            showObj.html(length + '/' + max);
		        });
		        if ($(this).val() != '') {
		            showObj.html($(this).val().length + '/' + max);
		        }
		    })
		}
		, file: function(parentid) {
		    initFile(parentid)
		}
		, radio: function(parentid, path) {
		    /*输出单选*/
		    var obj = $(document);
		    if (parentid) obj = $(parentid);
		    obj.find('[BindRadio]').each(function() {
		        if ($(this).parents('[notbind]').length > 0) return;
		        var obj = $(this);

		        var type = obj.attr('BindRadio');
		        var value = obj.attr('BindValue');
		        var name = obj.attr('BindName');
		        name = name || 'radio_' + parseInt(Math.random() * 10000);
		        var tmpl = '<label style="display:inline-block;"><input type="radio" name="' + name + '" value="${Value}"/>${Name}</label>';
		        var callback = function(html) {
		            obj.html(html);
		            if (value != null) {
		                obj.find('input[type="radio"]').each(function() {
		                    if (this.value == value) this.checked = true;
		                })
		            }
		        }
		        var path = path || '/AjaxPost/GetValueList/?ParentCode=';

		        if (type.indexOf('[') > -1) {
		            callback($.from.write(tmpl, $.toJs(type)));
		        } else if (type.indexOf('0-') > -1) {

		            $.from.post(path + type, tmpl, callback)
		        } else if (type.indexOf('/') > -1) {
		            $.from.post(type, tmpl, callback);
		        }

		    })
		}
		, checkbox: function(parentid, path) {
		    /*输出多选按钮*/
		    var obj = $(document);
		    if (parentid) obj = $(parentid);
		    obj.find('[BindCheckBox]').each(function() {
		        if ($(this).parents('[notbind]').length > 0) return;
		        var obj = $(this);

		        var type = obj.attr('BindCheckBox');
		        var value = obj.attr('BindValue');
		        var name = obj.attr('BindName');
		        name = name || 'radio_' + parseInt(Math.random() * 10000);
		        var tmpl = '<label style="display:inline-block;"><input type="checkbox" name="' + name + '" value="${Value}"/>${Name}</label>';
		        var callback = function(html) {
		            obj.html(html);
		            if (value != null) {
		                obj.find('input[type="checkbox"]').each(function() {
		                    if ((',' + value + ',').indexOf(',' + this.value + ',') > -1) this.checked = true;
		                })
		            }
		        }
		        var path = path || '/AjaxPost/GetValueList/?ParentCode=';

		        if (type.indexOf('[') > -1) {
		            callback($.from.write(tmpl, $.toJs(type)));
		        } else if (type.indexOf('0-') > -1) {
		            $.from.post(path + type, tmpl, callback)
		        } else if (type.indexOf('/') > -1) {
		            $.from.post(type, tmpl, callback);
		        }
		    })
		}
		, completion: function(parentid, tmpl, path) {
		    var tmpl = tmpl || '\
<div class="completion">\
    <div class="c-list">\
        <a href="javascript:;" foreach="1" for-key="a" for-data="" style="display:none;" data="{Name:\'${a.Name}\',Value:\'${a.Value}\'}">${a.Name}</a>  \
    </div>\
</div>\
';
		    var obj = $(document.body);
		    if (parentid) obj = $(parentid);
		    var path = path || '/AjaxPost/GetValueList/?ParentCode=';
		    obj.find('[completion]').each(function() {
		        if ($(this).parents('[notbind]').length > 0) return;
		        var type = $(this).attr('completion');
		        var fun = $(this).attr('completion-fun');
		        var is = $(this).attr('completion-is');
		        var width = $(this).attr('completion-width');
		        var postOnOff = true;
		        var _obj = this;
		        var timePost = null;
		        var listIsOn = false;
		        var listData = [];

		        var listObj = $(tmpl).appendTo(obj);
		        listObj = $(listObj);
		        listObj.hide();
		        if (width != null) listObj.css({ width: width })
		        var callback = function(data, value) {
		            listData = [];
		            if (is) {
		                value = '';
		            }
		            if (value == '') listData = data;
		            else {
		                for (var i = 0; i < data.length; i++) {
		                    if (data[i].Name.indexOf(value) > -1) listData[listData.length] = data[i];
		                }
		            }
		            postOnOff = true;
		            listObj.find('.c-list').children(':not([foreach])').remove();

		            listObj.show();
		            if (listData.length == 0) {
		                listObj.hide();
		                listIsOn = false;
		            } else {
		                listIsOn = true;
		                var offset = $._offset(_obj);
		                listObj.css({ left: offset.left + 'px', top: (offset.top + offset.height + 2) + 'px' });
		            }
		            $.list.write(listObj.find("[foreach]").get(0),
					{
					    'for-data': $.json(listData)
					});
		            listObj.find('.c-list').children(':not([foreach])').click(function() {
		                if (fun != null) window[fun](_obj, this, getData(this));
		            })
		            updownKey = -1;
		        }
		        var postData = function() {
		            var value = _obj.value;
		            if (value != $(_obj).attr('pevvalue')) {
		                $(_obj).attr('pevvalue', value);
		                if (!postOnOff) return;
		                postOnOff = false;
		                if (type.indexOf('[') > -1) {
		                    callback($.toJs(type), value);
		                } else if (type.indexOf('0-') > -1) {
		                    $.post(path + type, { value: value }, function(data) {
		                        callback($.toJs(data), value);
		                    });
		                } else if (type.indexOf('/') > -1) {
		                    $.post(type, { value: value }, function(data) {
		                        callback($.toJs(data), value);
		                    });
		                }

		            }
		            timePost = setTimeout(postData, 500);
		        }
		        $(_obj).focus(function() {
		            $(_obj).attr('pevvalue', '-1');
		            clearTimeout(timePost);
		            postData();
		        });
		        $(_obj).blur(function() {
		            clearTimeout(timePost);
		            setTimeout(function() { listObj.hide(); }, 200);
		        });
		        listObj.mouseover(function() {
		            var list = listObj.find('.c-list').children(':not([foreach])');
		            list.removeClass('on');
		            var link = $._event.findElement('a');
		            if (link != null) {
		                for (var i = 0; i < list.length; i++) {
		                    if (list[i] == link) {
		                        updownKey = i;
		                        list.get(updownKey).className = 'on';
		                        break;
		                    }
		                }
		            }
		        });
		        var updownKey = -1;
		        var getData = function(o) {
		            var d = $(o).attr('data');
		            var _d = $.toJs(d);
		            if (_d == null) return {};
		            return _d;
		        }

		        $(document).keydown(function() {
		            if (listIsOn) {
		                if (event.keyCode == 37 || event.keyCode == 38 || event.keyCode == 39 || event.keyCode == 40) {
		                    var list = listObj.find('.c-list').children(':not([foreach])');
		                    if (event.keyCode == 37 || event.keyCode == 38) updownKey -= 1;
		                    else if (event.keyCode == 39 || event.keyCode == 40) updownKey += 1;
		                    if (updownKey >= list.length) updownKey = 0;
		                    if (updownKey < 0) updownKey = list.length - 1;
		                    list.removeClass('on');
		                    var tObj = list.get(updownKey);
		                    tObj.className = 'on';
		                    var height = $._offset(tObj).height;
		                    var pHeight = $._offset(listObj.get(0)).height;
		                    if (height * (updownKey + 1) > pHeight) {
		                        listObj.scrollTop((height * (updownKey + 1)) - pHeight);
		                    } else {
		                        listObj.scrollTop(0);
		                    }
		                    //if(iswrite=="1")$(_obj).val(getData(list.get(updownKey)).Name);

		                }
		                if (event.keyCode == 13) {
		                    var list = listObj.find('.c-list').children(':not([foreach])');
		                    $(_obj).blur();
		                    if (updownKey < list.length) {
		                        if (fun != null) window[fun](_obj, list.get(updownKey), getData(list.get(updownKey)));
		                    }
		                }
		            }
		        });
		    })
		}
    }

    /*列表类*/

    var ForeachFun = function(data) {
        this.path = "/AjaxPost/GetValueList/?ParentCode=";
        if (data != null) {
            if (data.path != null) this.path = data.path;
        }
    }
    ForeachFun.prototype = {
        init: function(parentid, num) {
            if (num == null) num = 1;
            var pro = this;
            var obj = $(document);
            if (parentid) obj = $(parentid);
            obj.find('[foreach="' + num + '"]').each(function() {
                pro.run(this, num);
            });
            //this.endCallBack && this.endCallBack(parentid);
        }
    , run: function(o, num) {
        var pro = this;
        if (num == null) num = 1;
        var o = $(o);
        var tmpltext = $.outerHTML(o);
        var data = o.attr('for-data') ? o.attr('for-data'):this.fordata ;
        var forkey = o.attr('for-key');
        var forfun = o.attr('for-fun');
        var forwhere = o.attr('for-where');
       
        if (!data) return;
        if (forwhere != null) {
            try {
                if (!eval(forwhere)) {
                    if (isremove == null) o.hide();
                    else o.remove();
                    return;
                }
            } catch (e) { }
        }
        
        if (forfun == null) {
            if(data.constructor==Array){
            	pro.write(tmpltext, data, o, num, forkey, forwhere)
            } else if (data.indexOf('[') > -1) {
                pro.write(tmpltext, $.toJs(data), o, num, forkey, forwhere)
            } else if (data.indexOf('0-') > -1) {
                $.post(this.path + data, {}, function(e) {
                    if (typeof e == "string") e = $.toJs(e);
                    pro.write(tmpltext, e, o, num, forkey, forwhere)
                })
            } else if (data.indexOf('/') > -1) {
                $.post(data, {}, function(e) {
                    if (typeof e == "string") e = $.toJs(e);
                    pro.write(tmpltext, e, o, num, forkey, forwhere)
                })
            }
        } else {
            window[forfun] && window[forfun](o, data, function(data) {
                if (typeof e == "string") e = $.toJs(e);
                pro.write(tmpltext, e, o, num, forkey, forwhere);
            });
        }

    }
    , write: function(tmpltext, data, obj, num, forkey, forwhere) {
        var list = data;
        if (data == null) return;
        if (data['list'] != null) list = data['list'];
        var total = 0;
        if (data['total'] != null) total = data['total'];
        var p = 1;
        if (data.p != null) p = data.p;

        for (var i = 0; i < list.length; i++) {
            var _data = list[i];
            _data['forIndex'] = i + 1;
            _data['index'] = i;
            try {
                if (forwhere != null) {
                    if (!eval($.tmpl(forwhere, _data, forkey))) continue
                }
            } catch (e) { }
            var str = $.tmpl(tmpltext, _data, forkey);
            var s = $.string.analyze(str); //进行脚本解析执行
            var o = $(s).appendTo(obj.parent());
            var forload = o.attr('for-load');
            if (forload != null) {
                try {
                    eval($.tmpl(forload, _data, forkey))
                } catch (e) { window[forload] && window[forload](); }
            }
            $(o).removeAttr('foreach')
                .removeAttr('for-data')
                .removeAttr('for-key')
                .removeAttr('for-fun')
                .removeAttr('for-where')
                .removeAttr('for-isremove')
                .removeAttr('for-load')
                .removeAttr('notbind')
                .show();
            this.writeCallBack && this.writeCallBack(o);
            $(o).find('[imgsrc]').each(function(){
            	var src=$(this).attr('imgsrc');
            	var pro=this;
            	if(this.src==''){
            		$.cache.pic(src,function(path){
            			pro.src=path;
            		});
            	}
            })
            this.init(o, num + 1);
        }
        var isremove = obj.attr('for-isremove');
        if (isremove == null) obj.hide();
        else obj.remove();
        var allforload = obj.attr('for-load');
        if (allforload != null) {
            try {
                if (allforload.indexOf(')') > -1) eval(allforload);
                else window[allforload] && window[allforload]('endload');
            } catch (e) { window[allforload] && window[allforload]('endload'); }
        }
        if (num == 1) {
            this.endCallBack && this.endCallBack(this, total, p);
        }
    }
    };
    var Pager = function(ops) {
        this.core = null;
        this.list = [];
        this.pn = 1;
        this.tn = null;
        this.rn = null;
        this.count = null;
        this.init.apply(this, arguments);
    };

    $.extend(Pager.prototype, {
        init: function(ops) {
            $.extend(this, ops);
            this._bind();
        },
        render: function() {
            this.draw();
        },
        to: function(index) { },
        show: function() {
            $(this.core).show();
        },
        hide: function() {
            $(this.core).hide();
        },
        _bind: function() {
            var _self = this;
            $(this.core).click(function(e) {
                if (!e.target || e.target.nodeName != 'A' && e.target.nodeName != 'BUTTON') {
                    return;
                }
                if (e.target.nodeName == 'BUTTON') {
                    var pn = $('.pager-text', this.core).val();
                    if (isNaN(pn)) {
                        return;
                    }
                } else {
                    var pn = $(e.target).attr('data-pn');
                    if (isNaN(pn)) {
                        return;
                    }
                }
                e.preventDefault();
                if (_self.to(pn) === false) {
                    return;
                }
                _self.pn = (pn | 0) || 1;
                _self.draw();
            });
        },
        builder: function() {
            this.count = Math.ceil(this.tn / this.rn);
            this.list.length = 0;
            var list = this.list,
			tn = this.tn,
			rn = this.rn,
			pn = this.pn,
			count = this.count;
            if (count <= 1) {
                return;
            }
            if (pn > 1) {
                list.push({ type: 'prev', index: pn - 1, enabled: true });
            } else {
                list.push({ type: 'prev', enabled: false });
            }
            if (count > 12) {
                if (pn < 6) {
                    for (var i = 1; i <= Math.min(count, 7); ++i) {
                        if (pn == i) {
                            list.push({ type: 'index', index: i, selected: true });
                        } else {
                            list.push({ type: 'index', index: i, selected: false });
                        }
                    }
                    list.push({ type: 'last', index: count });
                } else if (pn + 6 > count) {
                    list.push({ type: 'first', index: 1 });
                    for (var i = Math.max(count - 7, 1); i <= count; ++i) {
                        if (pn == i) {
                            list.push({ type: 'index', index: i, selected: true });
                        } else {
                            list.push({ type: 'index', index: i, selected: false });
                        }
                    }
                } else {
                    list.push({ type: 'first', index: 1 });
                    for (var i = pn - 3; i < pn; ++i) {
                        list.push({ type: 'index', index: i, selected: false });
                    }
                    list.push({ type: 'index', index: pn, selected: true });
                    for (var i = pn + 1; i <= pn + 3; ++i) {
                        list.push({ type: 'index', index: i, selected: false });
                    }
                    list.push({ type: 'last', index: count });
                }
            } else {
                for (var i = 1; i <= count; ++i) {
                    if (pn == i) {
                        list.push({ type: 'index', index: i, selected: true });
                    } else {
                        list.push({ type: 'index', index: i, selected: false });
                    }
                }
            }
            if (pn < count) {
                list.push({ type: 'next', index: pn + 1, enabled: true });
            } else {
                list.push({ type: 'next', enabled: false });
            }
            if (count > 12) {
                list.push({ type: 'to', enabled: true });
            }
        },
        ToString: function() {
            var tpl = {
                index: function(e) {
                    if (!e.selected) {
                        return '<li><a href="' + e.index + '" data-pn="' + e.index + '">' + e.index + '</a></li>';
                    } else {
                        return '<li class="pager-selected">' + e.index + '</li>'
                    }
                },
                prev: function(e) {
                    if (e.enabled) {
                        return '<li class="pager-prev"><a href="' + e.index + '" data-pn="' + e.index + '"></a></li>';
                    } else {
                        return '<li class="pager-prev pager-none"></li>';
                    }
                },
                next: function(e) {
                    if (e.enabled) {
                        return '<li class="pager-next"><a href="' + e.index + '" data-pn="' + e.index + '"></a></li>';
                    } else {
                        return '<li class="pager-next pager-none"></li>';
                    }
                },
                to: function(e) {
                    return '<li class="pager-to">跳转到:<input type="text" class="pager-text" /><button type="button">GO</button></li>';
                },

                first: function(e) {
                    return '<li class="pager-first"><a href="' + e.index + '" data-pn="' + e.index + '">' + e.index + '</a></li><li class="pager-dot">...</li>';
                },

                last: function(e) {
                    return '<li class="pager-dot">...</li><li class="pager-last"><a href="' + e.index + '" data-pn="' + e.index + '">' + e.index + '</a></li>';
                }
            };
            var ret = [];
            for (var i = 0, list = this.list; i < list.length; ++i) {
                if (!tpl[list[i].type]) {
                    continue;
                }
                ret[i] = tpl[list[i].type](list[i]);
            }
            return '<ul>' + ret.join('') + '</ul>';
        },
        draw: function() {
            this.builder();
            $(this.core).html(this.ToString());
        }
    });
    var PagerClass = function(parentid) {
        this.init(parentid);
    }
    PagerClass.prototype = {
        init: function(parentid) {
            var pro = this;
            parentid = parentid || document.body;
            $(parentid).find('[pager]').each(function() {
                pro.run(this);
            });
        }
		, run: function(obj) {

		    var pro = this;
		    var data = $.toJs($(obj).attr('pager'));
		    var type = data.type || 'vertical';
		    var tmplObj = $(obj).find('[pager-tmpl]');
		    var tmpltext = $.outerHTML(tmplObj.get(0)); //模板
		    var forkey = $(tmplObj).attr('pager-key');
		    obj.path = data.path;
		    if (obj.swiperClass) {
		        this.post(data.path, data.p, data.size, function(d) {
		            $(obj).parent().find('.swiper-wrapper').html('');
		            pro.write(d.list, tmpltext, $(obj).parent().find('.swiper-wrapper'), forkey);
		            obj.swiperClass.reInit();
		        });
		        return;
		    }
		    $(obj).parent().css({ overflow: 'hidden' });
		    var subObj = $('<div class="swiper-wrapper"></div>').appendTo(obj);


		    var isLoad = true;
		    this.post(obj.path, data.p, data.size, function(d) {
		        pro.write(d.list, tmpltext, subObj, forkey);
		        //$(obj).attr('plength',d.list.length);
		        //$(obj).attr('tLength',(d.list.length-(d.list.length%2))/2-1);
		        var _pos = 0;
		        obj.swiperClass = $(obj).swiper({
		            mode: type,
		            slidesPerView: 'auto',
		            onResistanceAfter: function(s, pos) {
		                _pos = pos
		                //console.log(pos)
		            },
		            onTouchEnd: function(swiper) {
		                if ((_pos > 10) && isLoad) {
		                    data.load && data.load();
		                    _pos = 0;
		                    isLoad = false;

		                    pro.post(obj.path, d.p += 1, d.size, function(d) {
		                        pro.write(d.list, tmpltext, subObj, forkey);
		                        data.endload && data.endload();
		                        swiper.reInit();
		                        //var plength=$(obj).attr('plength')-0;
		                        //var nLength=d.list.length;
		                        //$(obj).attr('tLength',plength+(nLength-(nLength%2))/2-1);
		                        //$(obj).attr('plength',plength+nLength);
		                        isLoad = true;
		                    });
		                }
		            }
		        });
		    });
		}
		, write: function(arr, tmpltext, subObj, forkey) {
		    var str = [];
		    for (var i = 0; i < arr.length; i++) {
		        var o = $($.tmpl(tmpltext, arr[i], forkey)).appendTo(subObj);
		        $(o).addClass('swiper-slide');
		        $(o).removeAttr('pager-tmpl').removeAttr('pager-key');
		        $(o).show();
		    }
		}
		, post: function(path, p, size, callback) {
		    if (path.constructor == String) {
		        $.post(path, { p: p, size: size }, function(d) {
		            callback && callback(d);
		        });
		    } else {
		        callback && callback(path(p, size));
		    }
		}
    }
    $.list = {
        init: function(parentid, config) {
            var f = new ForeachFun();
            config = config || {};
            f.writeCallBack = function(o) {
                config.writeCallBack && config.writeCallBack(o, f)
            };
            f.endCallBack = function() {
                config.endCallBack && config.endCallBack(f)
            };
            f.init(parentid);
        }
		, write: function(obj, config) {
		    var f = new ForeachFun();
		    config = config || {};
		    if (config['for-data'] != null){
		    	if(config['for-data'].constructor == Array)f.fordata=config['for-data'];
		    	else $(obj).attr('for-data', config['for-data']);
		    } 
		    if (config['for-where'] != null) $(obj).attr('for-where', config['for-where']);
		    f.writeCallBack = config.writeCallBack;
		    f.endCallBack = config.endCallBack;
		    var num = $(obj).attr('foreach');
		    f.run(obj, num - 0);
		    return f;
		}
		, pager: function(parentid) {
		    new PagerClass(parentid);
		}
		, dataview: function(config, dataCallBack) {
		    config = config || {};
		    $(config.list).parent().children(':not([foreach])').remove();
		    var data = $.string.path(config.data);
		    if (data == null) data = {};
		    data.p = config.p || 1;
		    data.pagesize = config.pagesize || 10;
		    dataCallBack = dataCallBack || function(_d) {
		        return config.data.split('?')[0] + '?' + $._param(_d);
		    };
		    $.list.write(config.list, {
		        'for-data': dataCallBack(data)
				, endCallBack: function(pro, total, p) {
				    config.endCallBack && config.endCallBack();
				    var _pager = $(config.pager).get(0)['Pager'];
				    if (!_pager) {
				        _pager = new Pager({ core: config.pager, tn: total, rn: data.pagesize });
				        _pager.to = function(e) {
				            //页面切换后
				            config.p = e;
				            $.list.dataview(config, dataCallBack);
				        };
				        _pager.draw();
				        $(config.pager).get(0)['Pager'] = _pager;
				    } else {
				        _pager.tn = total;
				        _pager.to = function(e) {
				            //页面切换后
				            config.p = e;
				            $.list.dataview(config, dataCallBack);
				        };
				        _pager.draw();
				    }

				}
		    })
		}
    };

    /*验证类*/
    $.checks = {
        isContains: function(text, subStr) {
            /*字符串内判断是否存在某个字符串 */
            return text.indexOf(subStr) > -1;
        }
		, isRegExp: function(text, regExp) {
		    /*输入正则验证字符串*/
		    return (new RegExp(regExp)).test(text)
		}
		, isEmail: function(text) {
		    /*邮箱*/
		    return yString.isRegExp(text, "^[\\w-]+(\\.[\\w-]+)*@[\\w-]+(\\.[\\w-]+)+$");
		}
		, isInt: function(text) {
		    //整型
		    return $.checks.isRegExp(text, "^(-|\\+)?\\d+$");
		}
		, isFloat: function(text) {
		    //浮点型
		    return $.checks.isRegExp(text, "^(-|\\+)?\\d+(\\.\\d*)?$");
		}
		, isDate: function(text) {
		    /*日期*/
		    var r = text.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
		    if (r == null) return false;
		    var d = new Date(r[1], r[3] - 1, r[4]);
		    return (d.getFullYear() == r[1] && (d.getMonth() + 1) == r[3] && d.getDate() == r[4]);
		}
		, isNumber: function(text) {
		    /*数值*/
		    return $.checks.isRegExp(text, "^\\d*$");
		}
		, isPostalCode: function(text) { /*说明：邮政编码 无说明 */return $.checks.isRegExp(text, "^[a-zA-Z0-9 ]{3,12}$"); }
		, isUrl: function(text) { /*说明：url  无说明 */return $.checks.isRegExp(text, "^[a-zA-z]+://(\\w+(-\\w+)*)(\\.(\\w+(-\\w+)*))*(\\?\\S*)?$"); }
		, isPhone: function(text) { /*说明：手机号*/return $.checks.isRegExp(text, "^[0-9]{11}$"); }
		, isTel: function(text) { /*说明：座机号*/return $.checks.isRegExp(text, "(^[0-9]{3,4}\\-[0-9]{7,8}$)|(^[0-9]{7,8}$)|(^\\([0-9]{3,4}\\)[0-9]{7,8}$)|(^0{0,1}13[0-9]{9}$)"); }

    }
    /*数值类*/
    $.number = {
        thousands: function(num) {
            /*
            *说明：数字千分法
            *$.number.thousands(12312313)
            *12,312,313
            */
            num = num + "";
            var re = /(-?\d+)(\d{3})/
            while (re.test(num)) {
                num = num.replace(re, "$1,$2")
            }
            return num;
        }
		, getInterval: function(num, minIntervalNum, percentageNum) {
		    /*
		    **说明：获取区间值 num数值 minIntervalNum最小区间 percentageNum百分比(0.5)
		    **$.number.getInterval(330,16)
		    **20
		    */
		    var residue = num % minIntervalNum;
		    var interval = (num - residue) / minIntervalNum;
		    if (percentageNum != null && residue > minIntervalNum * percentageNum) interval += 1;
		    return interval;
		}
    }
    /*数组类*/
    $.array = {
        each: function(list, callBack) {
            /*说明：循环遍历数组 */
            /*参数：callBack：遍历数组时调用的方法*/
            if (list.length === undefined) {
                for (var key in list) {
                    if (callBack(list[key], key) == false) break;
                }
            } else {
                for (var i = 0, len = list.length; i < len; i++) {
                    if (callBack(list[i], i) == false) break;
                }
            }
        }
		, indexOf: function(list, object) {
		    /*说明：寻找数组内容跟参数相同的对象，返回索引 */
		    /*参数：object 关键字符串或对象*/
		    var len = list.length;
		    for (var i = 0; i < len; i++) {
		        if (typeof object == 'function') {
		            if (object(list[i], i) == true) return i;
		        } else {
		            if (list[i] == object) return i;
		        }
		    }
		    return -1;
		}
		, max: function(list, attr) {
		    /*返回最大值*/
		    var result;
		    $.array.each(list, function(value) {
		        if (attr == null) {
		            if (value >= (result || value)) result = value;
		        } else {
		            if (value[attr] >= (result[attr] || value[attr])) result = value;
		        }
		    });
		    return result;
		}
		, min: function(list, attr) {
		    /*返回最小值*/
		    var result;
		    $.array.each(list, function(value) {
		        if (attr == null) {
		            if (value <= (result || value)) result = value;
		        } else {
		            if (value[attr] <= (result[attr] || value[attr])) result = value;
		        }
		    });
		    return result;
		}
		, sort: function(list, callBack, attr, type) {
		    /*说明：冒泡排序 */
		    /*参数：callBack计算函数 默认x>y*/
		    type = type || 1;
		    callBack = callBack || function(x, y) {
		        if (type == 1) {
		            if (attr == null) return x > y;
		            else return x[attr] > y[attr];
		        } else {
		            if (attr == null) return x < y;
		            else return x[attr] < y[attr];
		        }
		    };
		    var len = list.length;
		    for (var j = len - 1; j > 0; j--) {
		        for (var i = 0; i < j; i++) {
		            if (callBack(list[i], list[i + 1])) {
		                var temp = list[i];
		                list[i] = list[i + 1];
		                list[i + 1] = temp;
		            }
		        }
		    }
		    return list;
		}
		, remove: function(list, key) {
		    /*说明：移除指定索引的数组内容*/
		    var thisList = [];
		    $.array.each(list, function(obj, i) {
		        if (key != i) thisList[thisList.length] = obj;
		    });
		    return thisList;
		}
		, addFirst: function(list, object) {
		    /*说明：添加一个元素到数组第一项 */
		    /*参数：object元素*/
		    var thisList = [object];
		    $.array.each(list, function(obj) {
		        thisList[thisList.length] = obj;
		    });
		    return thisList;
		}
		, addLast: function(list, object) {
		    /*说明：添加一个元素到数组最后项 */
		    /*参数：object元素*/
		    list[list.length] = object;
		    return list;
		}
		, unique: function(list, dataCallBack, returnCallBack) {
		    /*说明：数组元素除重，得到新数组 */
		    var thisHash = $.array.hash(list, dataCallBack);
		    var thisList = [];
		    $.array.each(thisHash, function(o, key) {
		        thisList[thisList.length] = returnCallBack ? returnCallBack(o, key) : key;
		    });
		    return thisList;
		}
		, hash: function(list, callBack) {
		    /*说明：将一个数组中的元素转换成hashtable。 */
		    var data = {};
		    $.array.each(list, function(o, key) {
		        if (callBack) callBack(o, key, data);
		        else {
		            if (!data[o]) data[o] = '';
		        }
		    });
		    return data;
		}
    }
    /*字符串类*/
    var ScriptAnalysis = function(tmpl) {
        this.tmpl = tmpl;
        this.scriptData = [];
        this.init();
    };
    ScriptAnalysis.prototype = {
        syntax: {//语法
            'if': { reg: /^\{\%if(.+?)then\%\}$/, rep: '$if' }
			, 'else': { reg: /^\{\%else\%\}$/, rep: '$else' }
			, 'endif': { reg: /^\{\%end if\%\}$/, rep: '$endif' }
        }
        //获取脚本数据
	, get: function(text) {
	    var script = [];
	    var scriptKey = 0;
	    var syntax = this.syntax;
	    var texts = text.replace(/\{\%(.+?)\%\}/g, function(a, b) {
	        for (var key in syntax) {
	            if (syntax[key].reg.test(a)) {
	                var attr = syntax[key].rep + scriptKey + "$";
	                script[attr] = a;
	                scriptKey += 1;
	                return attr;
	            }
	        }
	        return '';
	    });
	    this.scriptData = script;
	    return texts;
	}
        //递归解析语句，执行语句，并返回执行结果
	, analyze: function(text) {
	    var data = this.scriptData;
	    var sList = text.match(/\$if[0-9]+\$/g);
	    if (sList != null && sList.length > 0) {
	        var sKey = sList[sList.length - 1];
	        var yuju = text.replace(eval(("/(" + sKey + "([\\\w\\\W]+?)$endif[0-9]+$?)/").replace(/\$/g, '\\\$')), function(a, b, c, d) {
	            var _d = c.split(/\$else[0-9]+\$/);
	            var yunD = data[sKey];
	            if (eval(yunD.replace('{\%if', '').replace('then%}', '').replace(/and/g, '&&').replace(/or/g, '||').replace(/&gt;/g, '>'))) {
	                return _d[0];
	            } else {
	                if (_d.length > 1) return _d[1];
	                return '';
	            }
	        });
	        return this.analyze(yuju);
	    } else {
	        return text;
	    }
	}
        //初始化
	, init: function() {
	    this.tmpl = this.analyze(this.get(this.tmpl));
	}
    }
    $.string = {
        analyze: function(text) {
            /*对字符串进行脚本解析执行*/
            var s = new ScriptAnalysis(text);
            return s.tmpl;
        }
		, path: function(text) {
		    /*解析路径参数*/
		    var parameter = text.split('?')[1];
		    if (!parameter) { return null; }
		    var parameterHash = {}, parameter = '&' + parameter;
		    parameter.replace(/&([^=]+)=([^&]*)/g, function() {
		        parameterHash[arguments[1]] = arguments[2]
		    })
		    return parameterHash;
		}

		, byteLen: function(text) {
		    /*说明：获取字符串字节长度 */
		    /*返回结果：length 字符串长度*/
		    return text.replace(/[^\x00-\xff]/g, "--").length;
		}
		, tmpl: function(text, opts, key) {
		    /*
		    *说明：字符串模板，其中变量以${aaa}表示
		    */
		   
		   var zz=/\$\{([\w]+)\}/g;
		   if(key!=null)zz=eval('/\\$\\{'+key+'\\.([\\w]+)\\}/g');
		   return text.replace(zz, function(a, b) {
				if(opts[b]==undefined)return '';
				if (typeof opts[b] == 'object') return JSON.stringify(opts[b]).replace(/\"/g, "'"); 
				return opts[b]; 
			});
			   		
		}
		, subByte: function(text, len, tail) {
		    /*说明：得到指定字节长度的子字符串 */
		    if ($.string.byteLen(text) <= len) return text;
		    tail = tail || '';
		    return text = text.substr(0, len).replace(/([^\x00-\xff])/g, "$1 ")//双字节字符替换成两个
				.substr(0, len)//截取长度
				.replace(/[^\x00-\xff]$/, "")//去掉临界双字节字符
				.replace(/([^\x00-\xff]) /g, "$1") + tail; //还原
		}
		, clearHtml: function(text) {
		    return text.replace(/<[^>]+>/g, ""); //去掉所有的html标记
		}
		, toDate: function(text) {
		    /*说明：把字符串转换成Date格式 */
		    /*返回结果：Date*/
		    var converted = Date.parse(text);
		    var myDate = new Date(converted);
		    if (isNaN(myDate)) {
		        var arys = text.split(/[^\d]/);
		        myDate = new Date(arys[0], --arys[1], arys[2], arys[3] || null, arys[4] || null, arys[5] || null, arys[6] || null);
		    }
		    return myDate;
		}
		, toArray: function(text, splitText) {
		    /*说明：把字符串转换成数组 */
		    splitText = splitText || '';
		    return text.split(splitText);
		}
		, toNumber: function(text) {
		    /*把字符串转换成数值*/
		    return text.replace(/[^\d]+/g, '') - 0;
		}
		, toJs: function(jsonText) {
		    /*说明：把json字符串转换成js */
		    try {
		        jsonText = jsonText == '' ? '""' : jsonText;
		        return (new Function("return " + jsonText))();
		    } catch (e) {
		        return null;
		    }

		}
		, html_encode: function(str) {
		    if (typeof str != "string") return str;
		    var s = "";
		    if (str.length == 0) return "";
		    s = str.replace(/&/g, "&gt;");
		    s = s.replace(/</g, "&lt;");
		    s = s.replace(/>/g, "&gt;");
		    s = s.replace(/ /g, "&nbsp;");
		    s = s.replace(/\'/g, "&#39;");
		    s = s.replace(/\"/g, "&quot;");
		    s = s.replace(/\n/g, "<br>");
		    return s;
		}
        , html_decode: function(str) {
            if (typeof str != "string") return str;
            var s = "";
            if (str.length == 0) return "";
            s = str.replace(/&gt;/g, "&");
            s = s.replace(/&lt;/g, "<");
            s = s.replace(/&gt;/g, ">");
            s = s.replace(/&nbsp;/g, " ");
            s = s.replace(/&#39;/g, "\'");
            s = s.replace(/&quot;/g, "\"");
            s = s.replace(/<br>/g, "\n");
            return s;
        }
		, encodeHtml: function(s) {
		    return (typeof s != "string") ? s :
			s.replace(this.REGX_HTML_ENCODE,
				function($0) {
				    var c = $0.charCodeAt(0), r = ["&#"];
				    c = (c == 0x20) ? 0xA0 : c;
				    r.push(c); r.push(";");
				    return r.join("");
				});
		}
		, decodeHtml: function(s) {
		    return (typeof s != "string") ? s :
			s.replace(this.REGX_HTML_DECODE,
			function($0, $1) {
			    var c = this.HTML_ENCODE[$0];
			    if (c === undefined) {
			        if (!isNaN($1)) {
			            c = String.fromCharCode(($1 == 160) ? 32 : $1);
			        } else {
			            c = $0;
			        }
			    }
			    return c;
			});
		}
		,trim:function(s){
			 return s.replace(/(^\s*)|(\s*$)/g, "");
		}
    }
    /*时间类*/
    $.date = {
        format: function(date, pattern) {
            /*说明：日期格式化 */
            if (typeof (date) == 'string') date = $.string.toDate(date);
            var d = date;
            pattern = pattern || "yyyy-MM-dd";
            var y = d.getFullYear();
            var o = {
                "M": d.getMonth() + 1, //month
                "d": d.getDate(),    //day
                "h": d.getHours(),   //hour
                "m": d.getMinutes(), //minute
                "s": d.getSeconds() //second
            }
            pattern = pattern.replace(/(y+)/ig, function(a, b) { var len = Math.min(4, b.length); return (y + "").substr(4 - len); });
            for (var i in o) {
                pattern = pattern.replace(new RegExp("(" + i + "+)", "g"), function(a, b) { return (o[i] < 10 && b.length > 1) ? "0" + o[i] : o[i] });
            }
            return pattern;
        }
        , info: function(date, interval) {
            /*说明： 取得日期数据信息*/
            /*参数：interval：数据类型( y 年 m月 d日 w星期  h时 n分 s秒)*/
            /*调用方式：$.date.info("2004/11/12",'w')*/
            /*返回结果：1*/
          	if (typeof (date) == 'string') date = $.string.toDate(date);
            var myDate = date;
            var Week = ['日', '一', '二', '三', '四', '五', '六'];
            var data = {
                'y': myDate.getFullYear()
                , 'M': myDate.getMonth() + 1
                , 'd': myDate.getDate()
                , 'w': Week[myDate.getDay()]
                //,'ww':myDate.WeekNumOfYear()
                , 'h': myDate.getHours()
                , 'm': myDate.getMinutes()
                , 's': myDate.getSeconds()
            };
            if (typeof interval == 'string' && data[interval]) {
                return data[interval];
            } else if (interval == null) {
                return data;
            }
        }
		, diff: function(date, interval, dateStr) {
		    /*说明：时间差 (参数date减去this的时间差)*/
		    /*参数：interval：格式[y 年 M 月 d日 | h时 | m分 | s秒 t毫秒 ] date：计算时间*/
		    /*返回结果：1*/
		    var dtStart = date.constructor == Date ? date : $.string.toDate(date);
		    var dtEnd = dateStr.constructor == Date ? dateStr : $.string.toDate(dateStr);
		    var objInterval = {
		        't': 1
				, 's': 1000
				, 'm': 1000 * 60
				, 'h': 1000 * 60 * 60
				, 'd': 1000 * 60 * 60 * 24
				, 'w': 1000 * 60 * 60 * 24 * 7
		    };
		    try {
		        switch (interval) {
		            case 'M': return (dtEnd.getMonth() + 1) + ((dtEnd.getFullYear() - dtStart.getFullYear()) * 12) - (dtStart.getMonth() + 1);
		            case 'y': return dtEnd.getFullYear() - dtStart.getFullYear();
		            default: return Math.round((dtEnd - dtStart) / objInterval[interval]);
		        }
		    } catch (e) {
		        return e.message;
		    }
		}
		, days: function(date) {
		    /*说明：取得当前月的天数*/
		    /*参数：无*/
		    /*返回结果：30*/
		    var y = $.date.info(date, 'y'), m = $.date.info(date, 'M');
		    return new Date(y, m, 0).getDate();
		}
		, add: function(date, interval, number) {
		    /*说明：日期计算(在this时间上累加时间)*/
		    /*参数：interval：数据类型( y 年 M月 d日 w星期 q季度  h时 m分 s秒 t毫秒) number累加值*/
		    /*返回结果：Date*/
		    var dtTmp = date;
		    var objInterval = {
		        't': 1
				, 's': 1000
				, 'm': 1000 * 60
				, 'h': 1000 * 60 * 60
				, 'd': 1000 * 60 * 60 * 24
				, 'w': 1000 * 60 * 60 * 24 * 7
		    };
		    switch (interval) {
		        case 'q': return new Date(dtTmp.getFullYear(), (dtTmp.getMonth()) + number * 3, dtTmp.getDate(), dtTmp.getHours(), dtTmp.getMinutes(), dtTmp.getSeconds());
		        case 'M': return new Date(dtTmp.getFullYear(), (dtTmp.getMonth()) + number, dtTmp.getDate(), dtTmp.getHours(), dtTmp.getMinutes(), dtTmp.getSeconds());
		        case 'y': return new Date((dtTmp.getFullYear() + number), dtTmp.getMonth(), dtTmp.getDate(), dtTmp.getHours(), dtTmp.getMinutes(), dtTmp.getSeconds());
		        default: return new Date(Date.parse(dtTmp) + objInterval[interval] * number);
		    }
		}
        , is: function(date1, date2, type) {
            var isyear = (date1.getFullYear() == date2.getFullYear());
            var ismonth = (date1.getMonth() == date2.getMonth());
            var isdate = (date1.getDate() == date2.getDate());
            switch (type) {
                case "w": return isyear;
                case "m": return isyear && ismonth;
                case "d": return isyear && ismonth && isdate;
            }
            return isyear && ismonth && isdate;
        }
        , get: function(date, type) {
            var y = date.getFullYear();
            var m = date.getMonth() + 1;
            var d = date.getDate();
            var w = date.getDay();
            var n = w - 6;
            var ds = new Date(y, m, 0).getDate();

            if (type == 'w') {

                var dates = [];
                for (var i = 0; i < 7; i++) {
                    dates[dates.length] = new Date(y, m - 1, i + d + n);
                }
            }
            if (type == 'm') {
                for (var i = 1; i <= ds; i++) {
                    dates[dates.length] = new Date(y, m - 1, i);
                }
            }
            return dates;
        }
		, calendar: function(date, callBack, length) {
		    /*生成日历*/
		    var year = $.date.info(date, 'y'), month = $.date.info(date, 'M'),day=$.date.info(date, 'd');
		    var minDate = (new Date(year, month - 1, 1)).getDay();
		    minDate = minDate == 0 ? 7 : minDate;
		    var maxDate = $.date.days(date);
		    var prevMaxDate = $.date.days(new Date(year, month - 2, 1))
		    var thisNum = 1, nextNum = 1;
		    var len = maxDate + minDate;
		    len = len + (7 - len % 7);
		    len = length || len;
		    for (var i = 0; i < len; i++) {
		        if (i >= minDate && i <= maxDate + minDate - 1) {
		            var day6 = false;
		            var day0 = false;
		            var thisDay=false;
		            if (new Date(year, month - 1, thisNum).getDay() == 6) {
		                day6 = true;
		            }
		            if (new Date(year, month - 1, thisNum).getDay() == 0) {
		                day0 = true;
		            }
		            if(day==thisNum){
		            	thisDay=true;
		            }
		            callBack.thisTime && callBack.thisTime(thisNum, thisDay,day0, day6,month,year);
		            thisNum += 1;
		        } else if (i > maxDate + minDate - 1) {
		            callBack.nextTime && callBack.nextTime(nextNum,month+1,year);
		            nextNum += 1;
		        } else {
		            callBack.previousTime && callBack.previousTime(prevMaxDate-(minDate-i-1),month-1,year);

		        }
		    }
		}
    }
    $.weixin = {
        init: function(parentid) {
            $.weixin.wxPage(parentid);
            $.weixin.wxTab(parentid);

        }
		, get: function(id) {
		    if (window['WxPageData'] != null) {
		        return $.weixin.wxPage(null, window['WxPageData'][id]);
		    }
		    return null;
		}
		, getOffset: function(o) {
		    if ($(o).css('display') == 'none') {
		        $(o).show();
		        $(o).attr('isGet', '1');
		    }
		    $(o).parents().each(function() {
		        if ($(this).css('display') == 'none') {
		            $(this).show();
		            $(this).attr('isGet', '1');
		        }
		    });
		    var offset = $._offset(o);
		    if ($(o).attr('isGet') == '1') {
		        $(o).hide();
		    }
		    $(o).parents().each(function() {
		        if ($(this).attr('isGet') == '1') {
		            $(this).hide();
		        }
		    });
		    return offset;
		}
		, wxPage: function(parentid, pageid) {
		    if (window['WxPageData'] == null) window['WxPageData'] = {};
		    var WxPageData = window['WxPageData'];
		    if (pageid == null) {
		        parentid = parentid || document.body;
		        $(parentid).find('[wxPage]').each(function() {
		            var pro = this;
		            var data = $.toJs($(this).attr('wxPage'));
		            var c1 = $(this).children();
		            var c1_list = c1.children();
		            c1.addClass('swiper-wrapper');
		            c1_list.addClass('swiper-slide');
		            if (data.setHeight) {

		                var offset = $.weixin.getOffset(this);
		                c1_list.css({ height: offset.height + 'px' });
		            }
		            var aData = {};
		            if (data.type == 'vertical') {
		                aData.mode = 'vertical';
		                //aData.freeMode =true
		            }
		            if (data.loop) {
		                aData.loop = true;
		            }
		            if (data.autoplay) {
		                aData.autoplay = data.autoplay;
		            }
		            
		            aData.onTouchStart = function(swiper) {
		                var obj = swiper.activeSlide();
		                $.weixin.wxAn(obj, 0, pro);
		                for (var key in window['WxPageData']) {
		                    window['WxPageData'][key].reInit();
		                }
		                data.start && data.start(swiper.activeIndex, swiper.activeLoopIndex);
		            };
		            
		            aData.onTouchEnd = function(swiper) {
		                var obj = swiper.activeSlide();
		                $.weixin.wxAn(obj, 1, pro);
		                data.end && data.end(swiper.activeIndex, swiper.activeLoopIndex);

		            }
		            aData.onSlideChangeEnd = function(swiper) {
		                if (data.end) {
		                    if (typeof data.end == 'string') {
		                        window[data.end](swiper.activeIndex, swiper.activeLoopIndex);
		                    } else {
		                        data.end && data.end(swiper.activeIndex, swiper.activeLoopIndex);
		                    }
		                }
		            }
		            aData.onFirstInit = function(swiper) {
		                var obj = swiper.activeSlide();
		                $.weixin.wxAn(c1_list);
		                //initWxAn(c1_list);
		                $.weixin.wxAn(obj, 1, pro);

		            }
		            
		            var swiperObj = $(this).swiper(aData);
		            if (data.autoplay) {
		                //swiperObj.startAutoplay && swiperObj.startAutoplay();
		            }
		            var id = data.id || Math.random();
		            WxPageData[(id + '')] = swiperObj;
		            
		        });
		    } else {
		        return {
		            prev: function() {
		                WxPageData[pageid] && WxPageData[pageid].swipePrev();
		            }
					, next: function() {
					    WxPageData[pageid] && WxPageData[pageid].swipeNext();
					}
					, go :function(key,time){
						time=time || 1000;
						WxPageData[pageid] && WxPageData[pageid].swipeTo(key,time,false);
						
					}
		        }
		    }
		}
		, getAn: function(obj) {
		    obj = $(obj);
		    var data = $.toJs(obj.attr('wxAn'));
		    var startData = {};
		    var endData = {};
		    var callback = null;
		    var pos = obj.css('position');
		    if (pos == 'static') {
		        switch (data.type) {
		            case 'topfly': //从上飞入
		                startData = { marginTop: -100 };
		                endData = { marginTop: obj.css('margin-top') };
		                break;
		            case 'leftfly': //从左飞入
		                startData = { marginLeft: -100 };
		                endData = { marginLeft: obj.css('margin-left') };
		                break;
		            case 'rightfly': //从右飞入
		                startData = { marginRight: -100 };
		                endData = { marginRight: obj.css('margin-right') };
		                break;
		            case 'bottomfly': //从下飞入
		                startData = { marginBottom: -100 };
		                endData = { marginBottom: obj.css('margin-bottom') };
		                break;
		            case 'fadeout': //淡出
		                startData = { opacity: 0 };
		                endData = { opacity: obj.css('opacity') };
		                break;
		            case 'topfadeout': //从上淡出
		                startData = { marginTop: -100, opacity: 0 };
		                endData = { marginTop: obj.css('margin-top'), opacity: obj.css('opacity') };
		                break;
		            case 'leftfadeout': //从左淡出
		                startData = { marginLeft: -100, opacity: 0 };
		                endData = { marginLeft: obj.css('margin-left'), opacity: obj.css('opacity') };
		                break;
		            case 'rightfadeout': //从右淡出
		                startData = { marginRight: -100, opacity: 0 };
		                endData = { marginRight: obj.css('margin-right'), opacity: obj.css('opacity') };
		                break;
		            case 'bottomfadeout': //从下淡出
		                startData = { marginBottom: -100, opacity: 0 };
		                endData = { marginBottom: obj.css('margin-bottom'), opacity: obj.css('opacity') };
		                break;
		            case 'amplify': //放大
		                startData = { zIndex: 0 };
		                endData = { zIndex: 100 };
		                callback = function(now, fx) {
		                    $(this).css('-webkit-transform', 'scale(' + now / 100 + ')');
		                }
		                break;
		            case 'narrow': //缩小
		                startData = { zIndex: 0 };
		                endData = { zIndex: 100 };
		                callback = function(now, fx) {
		                    $(this).css('-webkit-transform', 'scale(' + (2 - now / 100) + ')');
		                }
		                break;
		        }
		    } else {
		        switch (data.type) {
		            case 'topfly': //从上飞入
		                startData = { top: -100 };
		                endData = { top: obj.css('top') };
		                break;
		            case 'leftfly': //从左飞入
		                startData = { left: -100 };
		                endData = { left: obj.css('left') };
		                break;
		            case 'rightfly': //从右飞入
		                startData = { right: -100 };
		                endData = { right: obj.css('right') };
		                break;
		            case 'bottomfly': //从下飞入
		                startData = { bottom: -100 };
		                endData = { bottom: obj.css('bottom') };
		                break;
		            case 'fadeout': //淡出
		                startData = { opacity: 0 };
		                endData = { opacity: obj.css('opacity') };
		                break;
		            case 'topfadeout': //从上淡出
		                startData = { top: -100, opacity: 0 };
		                endData = { top: obj.css('top'), opacity: obj.css('opacity') };
		                break;
		            case 'leftfadeout': //从左淡出
		                startData = { left: -100, opacity: 0 };
		                endData = { left: obj.css('left'), opacity: obj.css('opacity') };
		                break;
		            case 'rightfadeout': //从右淡出
		                startData = { right: -100, opacity: 0 };
		                endData = { right: obj.css('right'), opacity: obj.css('opacity') };
		                break;
		            case 'bottomfadeout': //从下淡出
		                startData = { bottom: -100, opacity: 0 };
		                endData = { bottom: obj.css('bottom'), opacity: obj.css('opacity') };
		                break;
		            case 'amplify': //放大
		                startData = { zIndex: 0 };
		                endData = { zIndex: 100 };
		                callback = function(now, fx) {
		                    $(this).css('-webkit-transform', 'scale(' + now / 100 + ')');
		                }
		                break;
		            case 'narrow': //缩小
		                startData = { zIndex: 0 };
		                endData = { zIndex: 100 };
		                callback = function(now, fx) {
		                    $(this).css('-webkit-transform', 'scale(' + (2 - now / 100) + ')');
		                }
		                break;
		        }
		    }

		    return { start: startData, end: endData, callback: callback };
		}
		, wxAn: function(parentid, type, pro) {
		    parentid = parentid || document.body;
		    $(parentid).find('[wxAn]').each(function() {
		        if (type == null) {
		            var data = $.weixin.getAn(this);
		            if ($(this).attr('endData') == null) {
		                $(this).attr('endData', $.json(data.end));
		                $(this).attr('startData', $.json(data.start));
		                this['callback'] = data.callback;
		                if (data.callback == null) {
		                    $(this).css(data.start);
		                } else {
		                    data.callback.call(this, 0, 1);
		                }
		            }
		        } else {
		            if ($(this).parents('[wxPage]').get(0) != pro) return;

		            var data = $.toJs($(this).attr('wxAn'));
		            var endData = $.toJs($(this).attr('endData'));
		            var startData = $.toJs($(this).attr('startData'));
		            var callback = this['callback'];
		            var speed = data.speed != null ? (data.speed * 1000) : 800;
		            var delay = data.delay != null ? (data.delay * 1000) : 0;
		            if (type == 1) $(this).stop(true).delay(delay).animate(endData, { duration: speed, step: callback });
		            else $(this).stop(true).delay(delay).animate(startData, { duration: speed, step: callback });
		        }
		    });

		}
		, wxTab: function(parentid) {
		    parentid = parentid || document.body;
		    $(parentid).find('[wxTab]').each(function() {
		        var id = $(this).attr('wxTab');
		        var tList = $(this).find('[tabfor]');
		        tList.each(function() {
		            $($(this).attr('tabfor')).hide();
		        })
		        $(this).find('[tabfor]').click(function() {
		            tList.each(function() {
		                $($(this).attr('tabfor')).hide();
		            });
		            $($(this).attr('tabfor')).show();
		            $.weixin.wxPage(null, id).next();
		        })

		    });
		}
    };
    $.img = {
        select: function(parentid) {
            parentid = parentid || document.body;
            $(parentid).find('[img-select]').each(function() {
                var obj = this;
                var data = $.toJs($(obj).attr('img-select'));

                var select = data.select;
                var init = data.init;
                var x = data.x - 0;
                var y = data.y - 0;
                var x2 = x + data.width - 0;
                var y2 = y + data.height - 0;
                var bl = data.width + ':' + data.height;
                var offset = $._offset(this);
                var sFun = function(o, s) { };
                try {
                    if (select.indexOf('function') > -1) {
                        sFun = eval(select);
                    } else {
                        sFun = window[select];
                    }
                } catch (e) { }
                var iFun = function(o, s) { };
                try {
                    if (init.indexOf('function') > -1) {
                        iFun = eval(init);
                    } else {
                        iFun = window[init];
                    }
                } catch (e) { }

                $(obj).imgAreaSelect({ aspectRatio: bl, handles: true, fadeSpeed: 10, onSelectChange: function(o, s) {
                    sFun(obj, { x: s.x1, y: s.y1, width: s.width, height: s.height, proWdith: obj.offsetWidth, proHeight: obj.offsetHeight })
                }, onInit: function() {
                    iFun(obj, { x: y, y: x, width: data.width, height: data.height, proWdith: obj.offsetWidth, proHeight: obj.offsetHeight });
                }, x1: x, y1: y, x2: x2, y2: y2
                });
            });
        }
        , set: function(id, width, height, selection) {
            var scaleX = width / selection.width;
            var scaleY = height / selection.height;
            $(id).css({ width: width + 'px', height: height + 'px' });
            var data = {
                width: Math.round(scaleX * selection.proWidth),
                height: Math.round(scaleY * selection.proHeight),
                marginLeft: -Math.round(scaleX * selection.x),
                marginTop: -Math.round(scaleY * selection.y)
            };
            $(id).find('img').css(data);
        }
    };
    $.canvas = {
        clear: function(id, width, height) {
            $(id).each(function() {
                var context = this.getContext("2d");
                width = width || 1000;
                height = height || 1000;
                context.clearRect(0, 0, width, height);
            })

        }
		, setBg: function(context, data) {
		    if (data.backgroundColor != null) {
		        context.fillStyle = data.backgroundColor;
		        context.fill();
		    }
		    if (data.border != null) {
		        context.strokeStyle = data.border;
		        context.stroke();
		    }
		}
		, run: function(obj) {
		    var datas = $.toJs($(obj).attr('canvas-data'));
		    var context = obj.getContext("2d");
		    for (var i = 0; i < datas.length; i++) {
		        var data = datas[i];
		        //平移
		        if (data.translate != null) {
		            context.translate(data.translate.x, data.translate.y);
		        }
		        //缩放
		        if (data.scale != null) {
		            context.scale(data.scale.x, data.scale.y);
		        }
		        //旋转
		        if (data.rotate != null) {
		            context.rotate(Math.PI / data.rotate);
		        }
		        context.beginPath();
		        //矩形
		        if (data.type == 'rectangle') {
		            context.lineTo(data.x, data.y);
		            context.lineTo(data.x + data.width, data.y);
		            context.lineTo(data.x + data.width, data.y + data.height);
		            context.lineTo(data.x, data.y + data.height);
		            context.lineTo(data.x, data.y);
		        }
		        //圆形
		        if (data.type == 'circle') {
		            var radian = 2;
		            if (data.radian != null) radian = data.radian;
		            context.arc(data.x, data.y, data.r, 0, Math.PI * radian, false);
		        }
		        //饼图
		        if (data.type == 'pie') {
		            var deltaArc = 0;
		            var sum = 0;

		            var circle = {};
		            circle.cx = data.width / 2;
		            circle.cy = data.height / 2;
		            circle.radius = Math.min(data.width / 2, data.height / 2) - data.size;
		            var fontSize = data.fontSize || 14;
		            var renderPie = function(ctx, index, precent, deltaArc, value) {
		                deltaArc = deltaArc;
		                var endAngle = deltaArc + 2 * Math.PI * precent;
		                ctx.beginPath();
		                var q0 = 90 * (Math.PI / 180); //console.log(((deltaArc-q0)*(180 / Math.PI)+360)%360,(360+endAngle-q0%360)*(180 / Math.PI))
		                ctx.arc(circle.cx, circle.cy, circle.radius, deltaArc - q0, endAngle - q0, false);
		                ctx.moveTo(circle.cx, circle.cy);
		                ctx.lineTo(circle.cx + circle.radius * Math.cos(deltaArc - q0), circle.cy + circle.radius * Math.sin(deltaArc - q0));
		                ctx.lineTo(circle.cx + circle.radius * Math.cos(endAngle - q0), circle.cy + circle.radius * Math.sin(endAngle - q0));
		                ctx.lineTo(circle.cx, circle.cy);
		                ctx.closePath();
		                ctx.fillStyle = data.datas[index].color;
		                ctx.fill();
		                //ctx.fillText(precent, 5, 60);
		                //ctx.restore();
		            }
		            var renderText = function(ctx, index, precent, deltaArc, value) {
		                deltaArc = deltaArc;
		                var endAngle = deltaArc + 2 * Math.PI * precent;
		                var q0 = 90 * (Math.PI / 180); //console.log(((deltaArc-q0)*(180 / Math.PI)+360)%360,(360+endAngle-q0%360)*(180 / Math.PI))
		                ctx.lineWidth = 2;
		                ctx.strokeStyle = '#ffffff';
		                ctx.fillStyle = "RGBA(255,255,255,1)";
		                //ctx.roundRect(2,2,30, 30, 5, true, true);
		                ctx.font = "14px Arial";
		                var q1 = value / 2 * (Math.PI / 180);
		                console.log(parseInt(value / 360 * 100) + '%', circle.cx + circle.radius / 1.4 * Math.cos(endAngle - q0 - q1), circle.cy + circle.radius / 1.4 * Math.sin(endAngle - q0 - q1), Math.cos(endAngle - q0 - q1), Math.sin(endAngle - q0 - q1))
		                var c = 0;
		                if (Math.sin(endAngle - q0 - q1) > 0) c = -10;
		                else c = -10;
		                ctx.fillText(parseInt(value / 360 * 100) + '%', circle.cx + circle.radius / 1.4 * Math.cos(endAngle - q0 - q1) + c, circle.cy + circle.radius / 1.4 * Math.sin(endAngle - q0 - q1));

		                //ctx.fillText(precent, 5, 60);
		                //ctx.restore();
		            }
		            var nums = data.datas.length;
		            for (var z = 0; z < nums; z++) {
		                sum += data.datas[z].value;
		            }
		            for (var z = 0; z < nums; z++) {
		                var precent = data.datas[z].value / sum;
		                renderPie(context, z, precent, deltaArc, data.datas[z].value);
		                deltaArc += 2 * Math.PI * precent;
		            }
		            deltaArc = 0;
		            for (var z = 0; z < nums; z++) {
		                var precent = data.datas[z].value / sum;
		                renderText(context, z, precent, deltaArc, data.datas[z].value);
		                deltaArc += 2 * Math.PI * precent;
		            }
		            /*
					
					data.cx = data.width/2;
		            data.cy = data.height/2;
		            data.radius = Math.min(data.width/2, data.height/2);
		            var precent = data.min/data.max;
		            var deltaArc=data.arc;
		            var endAngle = deltaArc + 2*Math.PI*precent;
		            context.arc(data.cx, data.cy, data.radius, deltaArc, endAngle, false);
		            context.moveTo(data.cx, data.cy);
		            context.lineTo(data.cx + data.radius * Math.cos(deltaArc), data.cy + data.radius * Math.sin(deltaArc));
		            context.lineTo(data.cx + data.radius * Math.cos(endAngle), data.cy + data.radius * Math.sin(endAngle));
		            context.lineTo(data.cx, data.cy);
		            */
		        }
		        //线形
		        if (data.type == 'line') {
		            if (data.xy != null) {
		                for (var z = 0; z < data.xy.length; z++) {
		                    var xy = data.xy[z];
		                    context.lineTo(xy.x, xy.y);
		                }
		            }
		        }
		        //贝塞尔曲线
		        if (data.type == 'bezier') {
		            if (data.sxy != null) {
		                context.moveTo(data.sxy.x, data.sxy.y);
		            }
		            if (data.cxy != null && data.exy != null) {
		                context.bezierCurveTo(data.sxy.x, data.sxy.y, data.cxy.x, data.cxy.y, data.exy.x, data.exy.y);
		            }
		        }
		        //椭圆形
		        if (data.type == 'elli') {
		            var a = data.r;
		            var b = data.r1;
		            var x = data.x - a / 2;
		            var y = data.y - b / 2;
		            var k = .5522848,
					ox = a * k, // 水平控制点偏移量
					oy = b * k; // 垂直控制点偏移量

		            //从椭圆的左端点开始顺时针绘制四条三次贝塞尔曲线
		            context.moveTo(x - a, y);
		            context.bezierCurveTo(x - a, y - oy, x - ox, y - b, x, y - b);
		            context.bezierCurveTo(x + ox, y - b, x + a, y - oy, x + a, y);
		            context.bezierCurveTo(x + a, y + oy, x + ox, y + b, x, y + b);
		            context.bezierCurveTo(x - ox, y + b, x - a, y + oy, x - a, y);
		        }
		        if (data.type == 'img') {
		            var image = new Image();
		            image.src = data.src;
		            image.onload = function() {
		                var x = data.x || 0;
		                var y = data.y || 0;
		                var width = data.width;
		                var height = data.height;
		                if (width != null && height != null) context.drawImage(image, x, y, width, height);
		                else context.drawImage(image, x, y);
		            }
		        }
		        if (data.type == 'clip') {
		            if (data.xy != null) {
		                for (var z = 0; z < data.xy.length; z++) {
		                    var xy = data.xy[z];
		                    context.lineTo(xy.x, xy.y);
		                }
		            }
		            context.clip();
		        }
		        $.canvas.setBg(context, data);

		        context.closePath();
		    }
		}
		, init: function(parentid) {
		    parentid = parentid || document.body;
		    $(parentid).find('[canvas-data]').each(function() {
		        $.canvas.run(this);
		    })
		}
    }
    var AdaptiveScreen=function(parent){
    	this.parent=parent || null;
    	this.datas=[];
    	this.width=0;
		this.height= 0;
    };
    AdaptiveScreen.prototype = {
	    
		add: function(d) {
		    this.datas[this.datas.length] = d;
		}
		
		, run: function() {
		    var pro=this;
		    var offset =this.get();
		    var width = offset.width;
		    var height = offset.height;
		    if (width != this.width || height != this.height) {
		        this.set(width, height);
		        this.width = width;
		        this.height = height;
		    }
		    setTimeout(function() {
		        pro.run();
		    }, 100);
		}
		, get :function(){
			if(this.parent==null){
				return $.windowInfo().client;
			}else{
				return $._offset(this.parent);
			}
		}
		, set: function(w, h) {
		    for (var i = 0; i < this.datas.length; i++) {
		        this.datas[i] && this.datas[i](w, h);
		    }
		}
		, reRun: function() {
		    this.width = 0;
		    this.height = 0;
		}
    }

	var newAdaptiveScreen=new AdaptiveScreen();
    $.page = {
        auto: function(callback,type) {
            if (callback) {
                newAdaptiveScreen.add(function(w, h) {
                    callback && callback(w, h);
                });
            } else if(!callback && type==null) {
                newAdaptiveScreen.run();
            }else{
            	newAdaptiveScreen.reRun();
            }
        }
    }
    $.abs=AdaptiveScreen;
    $(function() {
        setTimeout(function() {
            $.page.auto();
        }, 500);
    })
})(jQuery);